


/** 
 *
 * Main NESCafe Class.
 *
 * @author   David de Niese
 * @version  0.56f
 * @final    TRUE
 *
 */


final class NESCafe 
{


     /**
      *
      * The Current Version
      *
      */

      public static final double version = 0.56;

#ifdef STAND

     /**
      *
      * Startup Method.
      *
      */

      public static void main(String args[]) 
      {


         // Welcome Message

            System.out.println("Starting NESCafe v" + version );



         // Create Graphical User Interface and NES Machine

            if (!DavOS.checkVMNumber()) 
            {

               System.err.println("NESCafe cannot run on this computer. Please upgrade to the latest JVM");
               System.exit(1); 

            }

            try {

               // Create the GUI and NES

                  GUI gui = new GUI();
                  NES nes = new NES();


               // Initialise the NES Machine and the Graphical User Interface

                  nes.init(gui); 
                  gui.init(nes); 


				// Load Default ROM from JAR
					
					   nes.cartLoadDefault();
					                  


            } catch (Exception e) {

                  System.err.println("NESCafe cannot run on this computer. Please upgrade to the latest JVM");
                  System.exit(1);

            }

      }
#endif


}


